Subject: bug#71823: 31.0.50; project-mode-line and eglot duplicate project-name in mode-line

From: João Távora <[email-masked]>
Date: Wed, 3 Jul 2024 17:03:09 +0100

On Wed, Jul 3, 2024 at 4:12 PM Spencer Baugh <[email-masked]> wrote:
>
> João Távora <[email-masked]> writes:
>
> > On Wed, Jul 3, 2024 at 3:47 PM Spencer Baugh <[email-masked]> wrote:
> >
> >> Do any of these seem acceptable?
> >
> > No, sorry.
>
> When you originally said the patch was OK, how did you think the
> project-mode-line worked?

I said the idea was OK :-)  I forgot that Eglot's own display of
the project name is not only that.  It has more functionality:
the project name is only a label.  So what I thought would be a mere
replacement and is actually not.

> >> > I also don't understand the other changes (i.e. to the menu) but
> >> > that's OK.
> >>
> >> The project-name in the eglot mode line entry had the server menu
> >> attached to it.  Since the project-name is no longer present, the server
> >> menu isn't accessible.  To make the server menu accessible again, it's
> >> added to the main eglot menu.
> >
> > Ah right.  Well that unexpected side effect alone makes this
> > approach unacceptable.
>
> Why is that?  What's the problem with moving the server menu to the main
> menu?

Nothing in particular, but if we're going to do that, we might as well do
the other thing, which I still think is cleaner.

> >> But I don't want to delegate the responsibility of solving this problem
> >> to the user, I want the problem to just be gone: the entries should just
> >> not duplicate project-name.
> >
> > This problem wasn't introduced by Eglot.
>
> Definitely, but it seems like it is best to fix it in Eglot.

It's best to allow the user to choose, and Eglot doesn't have a way
to let the user choose (while project has). So let's give them one
in Eglot.

João